package ar.com.intrale.mobile.mercadopago;

import androidx.annotation.NonNull;

import com.mercadopago.android.px.core.MercadoPagoCheckout;

import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;

/** MercadopagoPlugin */
public class MercadopagoPlugin implements FlutterPlugin, MethodCallHandler {
  /// The MethodChannel that will the communication between Flutter and native Android
  ///
  /// This local reference serves to register the plugin with the Flutter Engine and unregister it
  /// when the Flutter Engine is detached from the Activity
  private MethodChannel channel;

  @Override
  public void onAttachedToEngine(@NonNull FlutterPluginBinding flutterPluginBinding) {
    channel = new MethodChannel(flutterPluginBinding.getBinaryMessenger(), "mercadopago");
    channel.setMethodCallHandler(this);
  }

  @Override
  public void onMethodCall(@NonNull MethodCall call, @NonNull Result result) {
    if (call.method.equals("startPayment")) {
      startPayment(call, result);
      result.success("Android " + android.os.Build.VERSION.RELEASE);
    } else {
      result.notImplemented();
    }
  }

  @Override
  public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
    channel.setMethodCallHandler(null);
  }

  private void startPayment(MethodCall call, Result result) {
      HashMap<String, Object> arguments = (HashMap<String, Object>) call.arguments;
      String publicKey = (String) arguments.get(MERCADO_PAGO_PUBLIC_KEY_ARG);
      String preferenceId = (String) arguments.get(MERCADO_PAGO_PREFERENCE_ID_ARG);

      new MercadoPagoCheckout.Builder(publicKey, preferenceId)
              .build().startPayment(IntraleApplication.this, MERCADO_PAGO_REQUEST_CODE);
    }
}
